export interface OpSpec {
    inputs: string[];
    outputs: string;
    fn: Function;
    async?: boolean;
}
export declare class Compiler {
    private deps;
    private cache;
    constructor(optable: Iterable<Function | OpSpec>);
    getParams(reqs: Iterable<string>, precomputed?: Iterable<string>): {
        intermediates: string[];
        params: string[];
    };
    compile(reqs: Iterable<string>, precomputed?: Iterable<string>): (args: {
        [key: string]: unknown;
    }) => any;
    getCalculator(reqs: Iterable<string>, precomputed?: Iterable<string>): Function;
    calculate(reqs: Iterable<string>, args: {
        [key: string]: unknown;
    }): {
        [key: string]: unknown;
    };
    interpret(reqs: Iterable<string>, args: {
        [key: string]: unknown;
    }): Promise<{
        [key: string]: unknown;
    }>;
    private traverse;
    private linearize;
}
